﻿using System;

class MathBase
{
    public virtual double GetPerimeter()
    {
        Console.WriteLine("GetPerimeter Error: You have hit the base class");
        return 0.0;
    }

    public virtual double GetArea()
    {
        Console.WriteLine("GetArea Error: You have hit the base class");
        return 0.0;
    }

    public virtual double GetVolume() { return 0.0; }
}

class Rectangle : MathBase
{
    private double length, width, height;

    public Rectangle(double l, double w, double h)
    {
        length = l;
        width = w;
        height = h;
    }

    public override double GetPerimeter()
    {
        return 2 * (length + width);
    }

    public override double GetArea()
    {
        return length * width;
    }

    public override double GetVolume()
    {
        return length * width * height;
    }
}

class Circle : MathBase
{
    private double radius, height;
    const double PI = 3.1416;

    public Circle(double r, double h)
    {
        radius = r;
        height = h;
    }

    public override double GetPerimeter()
    {
        return 2.0 * PI * radius;
    }

    public override double GetArea()
    {
        return PI * radius * radius;
    }

    public override double GetVolume()
    {
        return PI * radius * radius * height;
    }
}

class MathLib
{
    static void PrintGetArea(Rectangle shape)
    {
        Console.WriteLine(shape.GetArea());
    }

    static void Main()
    {
        const int NUM = 2;
        MathBase[] math = new MathBase[NUM];

        math[0] = new Rectangle(5.0, 6.0, 7.0);
        math[1] = new Circle(4.0, 8.0);

        for (int i = 0; i < NUM; ++i)
        {
            Console.WriteLine("Shape " + (i + 1) + " Perimeter: " + math[i].GetPerimeter());
            Console.WriteLine("Shape " + (i + 1) + " Area:      " + math[i].GetArea());
            Console.WriteLine("Shape " + (i + 1) + " Volume:    " + math[i].GetVolume() + "\n");
        }

        for (int i = 0; i < NUM; ++i)
        {
            math[i] = null;
        }
    }
}
